CREATE TABLE wazeccp_alert_types (
    "id" integer NOT NULL,
    "type" text NOT NULL,
    "subtype" text,
    CONSTRAINT "wazeccp_alert_types_pkey" PRIMARY KEY ("id")
) WITH (oids = false);

INSERT INTO "wazeccp_alert_types" ("id", "type", "subtype") VALUES
(1,  'ACCIDENT',  'ACCIDENT_MINOR'),
(2,  'ACCIDENT',  'ACCIDENT_MAJOR'),
(3,  'ACCIDENT',  'NO_SUBTYPE'),
(4,  'JAM',  'JAM_MODERATE_TRAFFIC'),
(5,  'JAM',  'JAM_HEAVY_TRAFFIC'),
(6,  'JAM',  'JAM_STAND_STILL_TRAFFIC'),
(7,  'JAM',  'JAM_LIGHT_TRAFFIC'),
(8,  'JAM',  'NO_SUBTYPE'),
(9,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD'),
(10,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_SHOULDER'),
(11,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER'),
(12,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_OBJECT'),
(13,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_POT_HOLE'),
(14,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_ROAD_KILL'),
(15,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_SHOULDER_CAR_STOPPED'),
(16,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_SHOULDER_ANIMALS'),
(17,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_SHOULDER_MISSING_SIGN'),
(18,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_FOG'),
(19,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_HAIL'),
(20,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_HEAVY_RAIN'),
(21,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_HEAVY_SNOW'),
(22,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_FLOOD'),
(23,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_MONSOON'),
(24,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_TORNADO'),
(25,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_HEAT_WAVE'),
(26,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_HURRICANE'),
(27,  'WEATHERHAZARD/HAZARD',  'HAZARD_WEATHER_FREEZING_RAIN'),
(28,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_LANE_CLOSED'),
(29,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_OIL'),
(30,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_ICE'),
(31,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_CONSTRUCTION'),
(32,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_CAR_STOPPED'),
(33,  'WEATHERHAZARD/HAZARD',  'HAZARD_ON_ROAD_TRAFFIC_LIGHT_FAULT'),
(34,  'WEATHERHAZARD/HAZARD',  'NO_SUBTYPE'),
(35,  'MISC',  'NO_SUBTYPE'),
(36,  'CONSTRUCTION',  'NO_SUBTYPE'),
(37,  'ROAD_CLOSED',  'ROAD_CLOSED_HAZARD'),
(38,  'ROAD_CLOSED',  'ROAD_CLOSED_CONSTRUCTION'),
(39,  'ROAD_CLOSED',  'ROAD_CLOSED_EVENT');

CREATE TABLE wazeccp_roads (
    "id" integer NOT NULL,
    "value" integer NOT NULL,
    "name" character varying(100) NOT NULL,
    CONSTRAINT "wazeccp_roads_pkey" PRIMARY KEY ("id"),
    CONSTRAINT "wazeccp_roads_unique_combo" UNIQUE ("value", "name")
) WITH (oids = false);

INSERT INTO "wazeccp_roads" ("id", "value", "name") VALUES
(1,  1,  'Streets'),
(2,  2,  'Primary Street'),
(3,  3,  'Freeways'),
(4,  4,  'Ramps'),
(5,  5,  'Trails'),
(6,  6,  'Primary'),
(7,  7,  'Secondary'),
(8,  8,  '4X4 Trails'),
(9,  9,  'Walkway'),
(10,  10,  'Pedestrian'),
(11,  11,  'Exit'),
(12,  12,  '?'),
(13,  13,  '?'),
(14,  14,  '4X4 Trails'),
(15,  15,  'Ferry crossing'),
(16,  16,  'Stairway'),
(17,  17,  'Private road'),
(18,  18,  'Railroads'),
(19,  19,  'Runway/Taxiway'),
(20,  20,  'Parking lot road'),
(21,  21,  'Service road');


CREATE TABLE wazeccp_alerts (
    id character varying(40) NOT NULL,
    uuid text NOT NULL,
    pub_millis bigint NOT NULL,
    pub_utc_date timestamp,
    road_type integer,
    "location" jsonb,
    street text,
    city text,
    country text,
    magvar integer,
    reliability integer,
    report_description text,
    report_rating integer,
    confidence integer,
    "type" text,
    subtype text,
    report_by_municipality_user boolean,
    thumbs_up integer,
    jam_uuid text,

    create_batch_id bigint,
    created_at timestamp with time zone,
    created_by character varying(150),
    update_batch_id bigint,
    updated_at timestamp with time zone,
    updated_by character varying(150),
    CONSTRAINT wazeccp_alerts_pkey PRIMARY KEY ("id")
) WITH (OIDS = FALSE);


CREATE TABLE wazeccp_irregularities (
    id character varying(40) NOT NULL,
    uuid text NOT NULL,
    detection_date_millis bigint NOT NULL,
    detection_date text,
    detection_utc_date timestamp,
    update_date_millis bigint NOT NULL,
    update_date text,
    update_utc_date timestamp,
    street text,
    city text,
    country text,
    is_highway boolean,
    speed real,
    regular_speed real,
    delay_seconds integer,
    seconds integer,
    "length" integer,
    trend integer,
    "type" text,
    severity real,
    jam_level integer,
    drivers_count integer,
    alerts_count integer,
    n_thumbs_up integer,
    n_comments integer,
    n_images integer,
    "line" jsonb,
    cause_type text,
    start_node text,
    end_node text,

    create_batch_id bigint,
    created_at timestamp with time zone,
    created_by character varying(150),
    update_batch_id bigint,
    updated_at timestamp with time zone,
    updated_by character varying(150),
    CONSTRAINT wazeccp_irregularities_pkey PRIMARY KEY ("id")
) WITH (OIDS = FALSE);


CREATE TABLE wazeccp_jams (
    id character varying(40) NOT NULL,
    uuid text NOT NULL,
    pub_millis bigint NOT NULL,
    pub_utc_date timestamp,
    start_node text,
    end_node text,
    road_type integer,
    street text,
    city text,
    country text,
    "delay" integer,
    speed real,
    speed_kmh real,
    "length" integer,
    turn_type text,
    "level" integer,
    blocking_alert_id text,
    "line" jsonb,
    "type" text,
    turn_line jsonb,

    create_batch_id bigint,
    created_at timestamp with time zone,
    created_by character varying(150),
    update_batch_id bigint,
    updated_at timestamp with time zone,
    updated_by character varying(150),
    CONSTRAINT wazeccp_jams_pkey PRIMARY KEY ("id")
) WITH (OIDS = FALSE);


CREATE INDEX wazeccp_jams_blocking_alert_id ON wazeccp_jams USING btree (blocking_alert_id);

CREATE INDEX wazeccp_jams_pub_utc_date ON wazeccp_jams USING btree (pub_utc_date);
